"""
 functions to match a bunch of fragment descriptors from a file

No user-servicable parts inside.  ;-)

"""
from __future__ import annotations
import os as os
from rdkix import Chem
from rdkix import RDConfig
__all__ = ['Chem', 'RDConfig', 'defaultPatternFileName', 'fn', 'fns', 'name', 'os']
def _CountMatches(mol, patt, unique = True):
    ...
def _LoadPatterns(fileName = None):
    ...
defaultPatternFileName: str = '/Users/runner/work/rdkix-pypi/rdkix-pypi/build/temp.macosx-11.0-arm64-cpython-311/rdkix_install/share/RDKix/Data/FragmentDescriptors.csv'
fn = None
fns: list  # value = [('fr_C_O', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8720>), ('fr_C_O_noCOO', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8860>), ('fr_Al_OH', <function _LoadPatterns.<locals>.<lambda> at 0x103ec87c0>), ('fr_Ar_OH', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8900>), ('fr_methoxy', <function _LoadPatterns.<locals>.<lambda> at 0x103ec89a0>), ('fr_oxime', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8a40>), ('fr_ester', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8ae0>), ('fr_Al_COO', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8b80>), ('fr_Ar_COO', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8c20>), ('fr_COO', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8cc0>), ('fr_COO2', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8d60>), ('fr_ketone', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8e00>), ('fr_ether', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8ea0>), ('fr_phenol', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8f40>), ('fr_aldehyde', <function _LoadPatterns.<locals>.<lambda> at 0x103ec8fe0>), ('fr_quatN', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9080>), ('fr_NH2', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9120>), ('fr_NH1', <function _LoadPatterns.<locals>.<lambda> at 0x103ec91c0>), ('fr_NH0', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9260>), ('fr_Ar_N', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9300>), ('fr_Ar_NH', <function _LoadPatterns.<locals>.<lambda> at 0x103ec93a0>), ('fr_aniline', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9440>), ('fr_Imine', <function _LoadPatterns.<locals>.<lambda> at 0x103ec94e0>), ('fr_nitrile', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9580>), ('fr_hdrzine', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9620>), ('fr_hdrzone', <function _LoadPatterns.<locals>.<lambda> at 0x103ec96c0>), ('fr_nitroso', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9760>), ('fr_N_O', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9800>), ('fr_nitro', <function _LoadPatterns.<locals>.<lambda> at 0x103ec98a0>), ('fr_azo', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9940>), ('fr_diazo', <function _LoadPatterns.<locals>.<lambda> at 0x103ec99e0>), ('fr_azide', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9a80>), ('fr_amide', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9b20>), ('fr_priamide', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9bc0>), ('fr_amidine', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9c60>), ('fr_guanido', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9d00>), ('fr_Nhpyrrole', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9da0>), ('fr_imide', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9e40>), ('fr_isocyan', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9ee0>), ('fr_isothiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x103ec9f80>), ('fr_thiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x103eca020>), ('fr_halogen', <function _LoadPatterns.<locals>.<lambda> at 0x103eca0c0>), ('fr_alkyl_halide', <function _LoadPatterns.<locals>.<lambda> at 0x103eca160>), ('fr_sulfide', <function _LoadPatterns.<locals>.<lambda> at 0x103eca200>), ('fr_SH', <function _LoadPatterns.<locals>.<lambda> at 0x103eca2a0>), ('fr_C_S', <function _LoadPatterns.<locals>.<lambda> at 0x103eca340>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0x103eca3e0>), ('fr_sulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x103eca480>), ('fr_prisulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x103eca520>), ('fr_barbitur', <function _LoadPatterns.<locals>.<lambda> at 0x103eca5c0>), ('fr_urea', <function _LoadPatterns.<locals>.<lambda> at 0x103eca660>), ('fr_term_acetylene', <function _LoadPatterns.<locals>.<lambda> at 0x103eca700>), ('fr_imidazole', <function _LoadPatterns.<locals>.<lambda> at 0x103eca7a0>), ('fr_furan', <function _LoadPatterns.<locals>.<lambda> at 0x103eca840>), ('fr_thiophene', <function _LoadPatterns.<locals>.<lambda> at 0x103eca8e0>), ('fr_thiazole', <function _LoadPatterns.<locals>.<lambda> at 0x103eca980>), ('fr_oxazole', <function _LoadPatterns.<locals>.<lambda> at 0x103ecaa20>), ('fr_pyridine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecaac0>), ('fr_piperdine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecab60>), ('fr_piperzine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecac00>), ('fr_morpholine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecaca0>), ('fr_lactam', <function _LoadPatterns.<locals>.<lambda> at 0x103ecad40>), ('fr_lactone', <function _LoadPatterns.<locals>.<lambda> at 0x103ecade0>), ('fr_tetrazole', <function _LoadPatterns.<locals>.<lambda> at 0x103ecae80>), ('fr_epoxide', <function _LoadPatterns.<locals>.<lambda> at 0x103ecaf20>), ('fr_unbrch_alkane', <function _LoadPatterns.<locals>.<lambda> at 0x103ecafc0>), ('fr_bicyclic', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb060>), ('fr_benzene', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb100>), ('fr_phos_acid', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb1a0>), ('fr_phos_ester', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb240>), ('fr_nitro_arom', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb2e0>), ('fr_nitro_arom_nonortho', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb380>), ('fr_dihydropyridine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb420>), ('fr_phenol_noOrthoHbond', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb4c0>), ('fr_Al_OH_noTert', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb560>), ('fr_benzodiazepine', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb600>), ('fr_para_hydroxylation', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb6a0>), ('fr_allylic_oxid', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb740>), ('fr_aryl_methyl', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb7e0>), ('fr_Ndealkylation1', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb920>), ('fr_Ndealkylation2', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb880>), ('fr_alkyl_carbamate', <function _LoadPatterns.<locals>.<lambda> at 0x103ecb9c0>), ('fr_ketone_Topliss', <function _LoadPatterns.<locals>.<lambda> at 0x103ecba60>), ('fr_ArN', <function _LoadPatterns.<locals>.<lambda> at 0x103ecbb00>), ('fr_HOCCN', <function _LoadPatterns.<locals>.<lambda> at 0x103ecbba0>)]
name: str = 'fr_HOCCN'
